{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<!--<script type="text/javascript" src="../Scheduler/kai-scheduler.js"></script>-->
    
<kai-scheduler>
    
</kai-scheduler>
<script type="text/javascript">
    {% endblock begin_javascript_fix %}

    {% block begin_javascript %} 
    
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            ProductTree:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldDisplay:'name',options:{where:'O',finish:null}}
            ,Client:{routeName:'BaseController-getComboValues',table:'clients'}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            var cnt=t.tabs.main.grid.getBody();
            $(cnt).css({'width':'100%','height':'100%'});
            cnt.append('<kai-scheduler style="width: 100%;height: 100%;margin:0px;position:relative;"><kai-scheduler-event-list></kai-scheduler-event-list></kai-scheduler>');
            t.forms = {};
            t.winAddChildRecord=false;
            t.win.maximize();
            t.scheduler=t.initScheduler(t.win);
        }
        ,initScheduler(win) {
            var t = this;
            var scheduler = t.scheduler = document.querySelector('kai-scheduler');
            //win.on('afterresize',function(){
            //    scheduler.fitStageIntoParentContainer();
            //});
            t.appType=((window.location.href.indexOf('149/pres')>-1||window.location.href.indexOf('1.40/kaynak2')>-1)?'pres-hat':'robot-kaynak');
            var translations = {
                tr: {
                "resource-list": {
                    "toggler-title": "İş İstasyonları"
                },
                "event-list": {
                    "toggler-title": "Tüm İş Emirleri"
                }
                }
            };

            scheduler.addEventListener('btnCancelClick', function() {
                t.refresh();
            });

            scheduler.addEventListener('btnSaveClick', function(data) {
                //console.log(data);
                t.save(data.detail.modified);
            });
            scheduler.addEventListener('eventBoxDblClick', function(data) {
                //console.log('eventBoxDblClick', data);
                var _data={
                    id:data.detail.event.id
                    ,resourceId:data.detail.event.resourceId
                    ,erprefnumber:data.detail.event.erprefnumber
                    ,title:data.detail.event.title
                    ,_production:data.detail.event._production
                    ,duration:data.detail.event.duration
                    ,tpp:data.detail.event.tpp
                };
                t.openTaskEditWindow(_data);
            });

            var copy = function(o) {
                var output, v, key;
                output = Array.isArray(o) ? [] : {};
                for (key in o) {
                    v = o[key];
                    output[key] = (typeof v === "object") ? copy(v) : v;
                }
                return output;
            };
            var _load = function() {
                // var events = _getRandomTasks();
                // var events = _getRandomTasks(100);
                var events = copy(t.data.Scheduler.records);
                for(var i = 0; i < events.length; i++){
                    events[i].id=events[i].id.toString();
                }
                events.sort(function(a, b) {
                    return a.start - b.start;
                });

                //for(var i = 0; i < events.length; i++){
                //  events[i].scheduled = false;
                //}
                resources = copy(t.data.Client.records);
                for(var i = 0; i < resources.length; i++){
                    resources[i].children=JSON.parse(resources[i].children);
                }
                // var plannedStops = copy(plannedStopsData);
                // events[0].resourceId = 3;
                // events[0].scheduled = true;

                var plannedStopsPattern = t.data.plannedStops.records;
                var weekDays = new Date(1549152000000).getDay() === 0
                    ? ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday']
                    : ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'];

                var generateDate = function(date, day, time) {
                    time = time.split(':');
                    var dFirst = new Date(date);
                    var d = new Date(date);
                    var dDay = d.getDay();
                    d.setDate(d.getDate() + (day + 7 - d.getDay()) % 7);
                    d.setHours(parseInt(time[0]), parseInt(time[1]), time.length > 2 ? parseInt(time[2]) : 0);
                    if (dFirst.getTime() >= d.getTime()) {
                        d.setDate(d.getDate() + 7);
                    }
                    return d.getTime();
                };
                var plannedStopColors = ['#98ADFC', '#BC90C1', '#7FCFD9', '#F69E68', '#A2BEE4'
                , '#C0B5A9', '#929384', '#A2555E', '#28979D', '#6FBFAF', '#ABB284', '#D269A9'
                , '#F0EDA1', '#B09C78', '#C298FC', '#ACD58E', '#FF7C7C', '#B16A45', '#887A70'
                , '#7E878C', '#AC8C02', '#A998FC', '#6EC095', '#FFD800', '#ACDEE6', '#C7D781'
                , '#E7997F', '#D4ADD1', '#97857C', '#A27704', '#54C6D5', '#6FC05D', '#525E66'
                , '#B49F64', '#C95E28', '#A4A5A4', '#F688FD', '#F18030', '#999441', '#ABA6C0'
                , '#EE2D27', '#529FD3', '#AF8B9F', '#009A87', '#B3910A', '#466F8C', '#A7B6B0'
                , '#66A783', '#E67990', '#EE6821', '#AAA3A8', '#EB831D', '#608D77', '#90A0C0'
                , '#9B5D49', '#B0AE7B', '#C0B0B5', '#615F4B', '#9488C1', '#F1AB15', '#006D53'
                , '#56C7DC', '#7D8FC8', '#5C751D', '#DFC58E', '#00B47B', '#7090A8', '#67904B'
                , '#577BBD', '#DDB10A', '#888B20', '#67AD96', '#9D8ABD', '#B75E72', '#C6886B'
                , '#00ADDE', '#61BD62', '#885C3B', '#AD7AB5', '#B0A49A', '#FBB480', '#A6AEB4'
                , '#A4998C', '#B47E69', '#438382', '#929962', '#7B759F', '#818B96', '#C68D69'
                , '#769A97', '#65C296', '#B1BE2D', '#F79668', '#5C7D37', '#78B2BB', '#4C7032'
                , '#719BD1', '#40816A', '#ADD581', '#009091'];
                var plannedStopAssignedColors = {};
                var plannedStopAssignedColorIndex = 0;
                var fnPlannedStopFactory = function(resourceId, startMs, endMs) {
                    /*
                    {
                        'id': '39239085',
                        'dateStart': '1540506600000',
                        'dateEnd': '1540507200000',
                        'description': 'CAY PAYDOSU 01:30~01:40',
                        'color': '#ffaaaa'
                    }
                    */
                    var result = [];
                    for (var i = 0; i < plannedStopsPattern.length; i++) {
                        var pattern = plannedStopsPattern[i];
                        var description = pattern.name ? pattern.name : pattern.losttype;
                        var color = plannedStopAssignedColors[description] ? plannedStopAssignedColors[description] : plannedStopAssignedColors[description] = plannedStopColors[plannedStopAssignedColorIndex++ % plannedStopColors.length];
                        var clients = pattern.clients ? pattern.clients.split('|') : [];
                        clients = clients.filter(function(item) {
                            return item === resourceId;
                        });

                        if (clients.length === 1) {
                            var patternStartMs = pattern.startday ? Math.max(startMs, new Date(pattern.startday).getTime()) : startMs;
                            var patternEndMs = pattern.finishday ? Math.min(endMs, new Date(pattern.finishday).getTime()) : endMs;
                            if (pattern.repeattype === 'day') {
                                var days = pattern.days.split('|');
                                for (j = 0; j < days.length; j++) {
                                    var dayIndex = weekDays.indexOf(days[j]);
                                    var dateStart = patternStartMs;
                                    while (dateStart === patternStartMs || dateStart < patternEndMs) {
                                        dateStart = generateDate(dateStart, dayIndex, pattern.starttime);
                                        var dateEnd = generateDate(dateStart, dayIndex, pattern.finishtime+ ':59');
                                        if (dateEnd < dateStart) {
                                            dateEnd = (new Date(dateEnd)).setDate(dateEnd.getDate() + 1).getTime();
                                        }
                                        // console.log(new Date(dateStart), new Date(dateEnd), description, resourceId);
                                        result.push({
                                            dateStart,
                                            dateEnd,
                                            description,
                                            color
                                        });
                                    }
                                }
                            }
                        }
                    }
                    return result;
                };

                var predecessors = (event, events) => {
                    var opNo = parseInt(event.title.split('-')[1]);
                    if (opNo > 10) {
                        var prevOpNo = opNo - 10;
                        for (var eventToCheck of events) {
                            var eventToCheckOpNo = parseInt(eventToCheck.title.split('-')[1]);
                            if (eventToCheck.orderNo === event.orderNo && eventToCheckOpNo === prevOpNo) {
                                return [{
                                    event: eventToCheck,
                                    relationTarget: 'START',
                                    timeDiffMs: undefined
                                }];
                            }
                        }
                    }
                };

                var successors = (event, events) => {
                    var opNo = parseInt(event.title.split('-')[1]);
                    if (opNo < 50) {
                        var nextOpNo = opNo + 10;
                        for (var eventToCheck of events) {
                            var eventToCheckOpNo = parseInt(eventToCheck.title.split('-')[1]);
                            if (eventToCheck.orderNo === event.orderNo && eventToCheckOpNo === nextOpNo) {
                                return [{
                                    event: eventToCheck,
                                    relationTarget: 'START',
                                    timeDiffMs: undefined
                                }];
                            }
                        }
                    }
                };

                var eventListColumns = [
                    { key: 'erprefnumber', title: 'ERP Ref.', width: 70 },
                    { key: 'title', title: 'Operasyon', width: 110 },
                    { key: '_production', title: 'Adet', width: 50 },
                    {
                        key: 'start',
                        title: 'event-list.event-start',
                        width: 116,
                        cellRenderer: (cellData, _rowData, _column, _locale, canvasGroup, font, horizontalPadding, rowHeight) => {
                            var text = cellData.toLocaleString('tr-tr', { day: '2-digit', month: '2-digit', year: 'numeric', hour: '2-digit', minute: '2-digit' });
                            if (canvasGroup) {
                            const title = new Konva.Text({
                                fill: font.color,
                                fontFamily: font.family,
                                fontSize: font.size,
                                text,
                                x: horizontalPadding,
                                y: (rowHeight - font.size) / 2,
                                perfectDrawEnabled: false,
                                hitStrokeWidth: 0,
                                shadowForStrokeEnabled: false,
                                listening: false,
                            });
                            title.transformsEnabled('position');
                            canvasGroup.add(title);
                            }
                            return text;
                        },
                    },
                ];
                var eventListColumnsPres = [
                    { key: 'erprefnumber', title: 'ERP Ref.', width: 70 },
                    { key: 'title', title: 'Operasyon', width: 110 },
                    { key: 'description', title: 'Operasyon Kodu', width: 110 },
                    { key: '_production', title: 'Adet', width: 50 },
                    {
                        key: 'start',
                        title: 'event-list.event-start',
                        width: 116,
                        cellRenderer: (cellData, _rowData, _column, _locale, canvasGroup, font, horizontalPadding, rowHeight) => {
                            var text = cellData.toLocaleString('tr-tr', { day: '2-digit', month: '2-digit', year: 'numeric', hour: '2-digit', minute: '2-digit' });
                            if (canvasGroup) {
                            const title = new Konva.Text({
                                fill: font.color,
                                fontFamily: font.family,
                                fontSize: font.size,
                                text,
                                x: horizontalPadding,
                                y: (rowHeight - font.size) / 2,
                                perfectDrawEnabled: false,
                                hitStrokeWidth: 0,
                                shadowForStrokeEnabled: false,
                                listening: false,
                            });
                            title.transformsEnabled('position');
                            canvasGroup.add(title);
                            }
                            return text;
                        },
                    },
                ];

                var LEAF_MASK_STEP = 2;
                t.data.Mould._fiksturCache = {};
                resources.forEach(client => {
                    if (typeof client.children === 'string') {
                        client.children = JSON.parse(client.children);
                    }
                    if(t.appType==='robot-kaynak') {
                        client.children.forEach(child => {
                            var moulds = t.data.Mould.records.filter(row => {
                                return row.client === child.id;
                            });
                            if (typeof t.data.Mould._fiksturCache[client.id] === 'undefined') {
                                t.data.Mould._fiksturCache[client.id] = [];
                            }
                            t.data.Mould._fiksturCache[client.id] = t.data.Mould._fiksturCache[client.id].concat(moulds);
                        })
                    }
                });

                var mergeCandidatesKaynak = (event, events) => {
                    // if (event.id === 25466) {
                    //   debugger;
                    // }
                    if (t.data.Mould && t.data.Mould._fiksturCache && t.data.Mould._fiksturCache[event.resourceId]) {
                        var candidates = [];
                        // var moulds = t.data.Mould.records.filter(row => {
                        //     return row.opname === event.title;
                        // });
                        var moulds = t.data.Mould._fiksturCache[event.resourceId].filter(row => {
                            return row.opname === event.title;
                        });
                        moulds.sort(function(a, b) {
                            return a.mould < b.mould;
                        });
                        var candidatesOfMould = [];
                        var mould = false, lastMould, allowPartialMerge;
                        var pushCandidates = function(candidatesOfMould, allow) {
                            for (var j = 0; j < candidatesOfMould.length; j++) {
                                candidatesOfMould[j].allowPartialMerge = allow;
                            }
                            candidates = [...candidates, ...candidatesOfMould];
                        };
                        for (var i = 0; i < moulds.length; i++) {
                            mould = moulds[i].mould;
                            if (mould !== lastMould) {
                                allowPartialMerge = false;
                            }
                            var targetResources = [];
                            if (moulds[i].client) {
                                targetResources.push(moulds[i].client);
                            }
                            if (moulds[i].client1) {
                                targetResources.push(moulds[i].client1);
                            }
                            if (moulds[i].client2) {
                                targetResources.push(moulds[i].client2);
                            }
                            if (moulds[i].client3) {
                                targetResources.push(moulds[i].client3);
                            }
                            if (moulds[i].client4) {
                                targetResources.push(moulds[i].client4);
                            }
                            if (moulds[i].client5) {
                                targetResources.push(moulds[i].client5);
                            }
                            targetResources = targetResources.join(',');
                            var mouldgroup = moulds[i].mouldgroup;
                            var mouldId = mould + ':|:' + mouldgroup;
                            if (!t.data.Mould._cache) {
                                t.data.Mould._cache = {};
                            }
                            if (!t.data.Mould._cache[mouldId]) {
                                t.data.Mould._cache[mouldId] = t.data.Mould.records.filter(row => {
                                    return row.mould === mould && row.mouldgroup === mouldgroup;
                                });
                            }
                            var group = t.data.Mould._cache[mouldId];
                            if (group && group.length > 0) {
                                var detail = {};
                                for (var j = 0; j < group.length; j++) {
                                    // if (group[j].opname === event.title) {
                                    //   continue;
                                    // }
                                    if (!t.data.Scheduler._cache) {
                                        t.data.Scheduler._cache = {};
                                    }
                                    if (!t.data.Scheduler._cache[group[j].opname]) {
                                        t.data.Scheduler._cache[group[j].opname] = t.data.Scheduler.records.filter(row => {
                                            return row.title === group[j].opname;
                                        });
                                    }
                                    // TODO: Üretim adedi, leafmask kontrolü yaparak detail'e ekle
                                    detail[group[j].opname] = group[j].opname === event.title ? [event] : t.data.Scheduler._cache[group[j].opname];
                                    if (detail[group[j].opname].length === 1) {
                                        allowPartialMerge = true;
                                    }
                                }
                                candidatesOfMould.push({
                                    mouldName: mould,
                                    groupName: mouldgroup,
                                    detail,
                                    allowPartialMerge: undefined,
                                    targetResources,
                                    durationCalculator: (event, duration, events, groupName, merge) => {
                                        const tpp = getCorrectTppKaynak(event, event.scheduleRelation.mergeCandidates);

                                        var production = duration / tpp;
                                        var mouldId = merge.mouldName + ':|:' + groupName;
                                        var group = t.data.Mould._cache[mouldId];
                                        if(typeof group==='undefined'){
                                            debugger;
                                        }
                                        var groupDetailOfEvent = group.filter(groupDetail => groupDetail.opname === event.title)[0];
                                        if (!groupDetailOfEvent) {
                                            debugger;
                                        }
                                        var totalProductionOfStepCycle = 0;
                                        var leafmask = groupDetailOfEvent.leafmask;
                                        var totalStepsOfCycle = leafmask.length / LEAF_MASK_STEP;
                                        while (leafmask.length > 0) {
                                            totalProductionOfStepCycle += parseInt(leafmask.substr(0, LEAF_MASK_STEP));
                                            leafmask = leafmask.substr(LEAF_MASK_STEP);
                                        }
                                        var totalCycleCount = production / totalProductionOfStepCycle;
                                        return parseFloat(groupDetailOfEvent.cycletime) * totalCycleCount;
                                    },
                                    remainingDurationCalculator: (event, recentMerges) => {
                                        var remaining = event._production;
                                        const tpp = getCorrectTppKaynak(event, event.scheduleRelation.mergeCandidates);
                                        // if (event.title == '16.13049/0010AB-10') {
                                        //   debugger;
                                        // }
                                        for (const m of recentMerges) {
                                            if (m.merge) {
                                                var mouldId = m.merge.mouldName + ':|:' + m.merge.groupName;
                                                var group = t.data.Mould._cache[mouldId];
                                                var groupDetailOfEvent = group.filter(groupDetail => groupDetail.opname === event.title)[0];
                                                var totalProductionOfStepCycle = 0;
                                                var leafmask = groupDetailOfEvent.leafmask;
                                                var totalStepsOfCycle = leafmask.length / LEAF_MASK_STEP;
                                                while (leafmask.length > 0) {
                                                    totalProductionOfStepCycle += parseInt(leafmask.substr(0, LEAF_MASK_STEP));
                                                    leafmask = leafmask.substr(LEAF_MASK_STEP);
                                                }
                                                remaining -= totalProductionOfStepCycle * m.duration / parseFloat(groupDetailOfEvent.cycletime) / 1000;
                                            } else {
                                                remaining -= m.duration / tpp / 1000;
                                            }
                                        }
                                        return remaining * tpp * 1000;
                                    }
                                });
                            }
                            if (mould !== lastMould) {
                                pushCandidates(candidatesOfMould, allowPartialMerge);
                                candidatesOfMould = [];
                            }
                            lastMould = mould;
                        }
                        if (candidatesOfMould.length > 0) {
                            pushCandidates(candidatesOfMould, allowPartialMerge);
                        }
                        return candidates;
                    }
                };

                var mergeCandidatesPres = (event, events) => {
                    // if (event.id === 617) {
                    //   debugger;
                    // }
                    // if (event.erprefnumber == 72713962) {
                    //   debugger;
                    // }
                    if (t.data.Mould && t.data.Mould.records) {
                        var candidates = [];
                        var moulds = t.data.Mould.records.filter(row => {
                            return row.opname === event.title;
                        });
                        moulds.sort(function(a, b) {
                            return a.mould < b.mould;
                        });
                        var candidatesOfMould = [];
                        var mould = false, lastMould, allowPartialMerge;
                        var pushCandidates = function(candidatesOfMould, allow) {
                            for (var j = 0; j < candidatesOfMould.length; j++) {
                                candidatesOfMould[j].allowPartialMerge = allow;
                            }
                            candidates = [...candidates, ...candidatesOfMould];
                        };
                        for (var i = 0; i < moulds.length; i++) {
                            mould = moulds[i].mould;
                            if (mould !== lastMould) {
                                allowPartialMerge = false;
                            }
                            var targetResources = [];
                            if (moulds[i].client1) { targetResources.push(moulds[i].client1); }
                            if (moulds[i].client2) { targetResources.push(moulds[i].client2); }
                            if (moulds[i].client3) { targetResources.push(moulds[i].client3); }
                            if (moulds[i].client4) { targetResources.push(moulds[i].client4); }
                            if (moulds[i].client5) { targetResources.push(moulds[i].client5); }
                            targetResources = targetResources.join(',');
                            var mouldgroup = moulds[i].mouldgroup;
                            var mouldId = mould + ':|:' + mouldgroup;
                            if (!t.data.Mould._cache) {
                                t.data.Mould._cache = {};
                            }
                            if (!t.data.Mould._cache[mouldId]) {
                                t.data.Mould._cache[mouldId] = t.data.Mould.records.filter(row => {
                                    return row.mould === mould && row.mouldgroup === mouldgroup;
                                });
                            }
                            var group = t.data.Mould._cache[mouldId];
                            if (group && group.length > 0) {
                                var detail = {};
                                for (var j = 0; j < group.length; j++) {
                                    // if (group[j].opname === event.title) {
                                    //   continue;
                                    // }
                                    if (!t.data.Scheduler._cache) {
                                        t.data.Scheduler._cache = {};
                                    }
                                    if (!t.data.Scheduler._cache[group[j].opname]) {
                                        t.data.Scheduler._cache[group[j].opname] = events.filter(_eventData => {
                                            return _eventData.title == group[j].opname;
                                        });
                                    }
                                    // TODO: Üretim adedi, leafmask kontrolü yaparak detail'e ekle
                                    detail[group[j].opname] = group[j].opname === event.title ? [event] : t.data.Scheduler._cache[group[j].opname];
                                    allowPartialMerge = false;
                                    // if (detail[group[j].opname].length === 1) {
                                    //   allowPartialMerge = true;
                                    // }
                                }
                                candidatesOfMould.push({
                                    mouldName: mould,
                                    groupName: mouldgroup,
                                    detail,
                                    allowPartialMerge: undefined,
                                    targetResources,
                                    durationCalculator: (event, duration, events, groupName) => {
                                        const tpp = getCorrectTppPres(event, event.scheduleRelation.mergeCandidates);

                                        var production = duration / tpp;
                                        var groupDetailOfEvent = group.filter(groupDetail => groupDetail.opname === event.title)[
                                        0];
                                        //if (!groupDetailOfEvent) {
                                        //    debugger;
                                        //}
                                        var totalProductionOfStepCycle = 0;
                                        var leafmask = groupDetailOfEvent.leafmask;
                                        var totalStepsOfCycle = leafmask.length / LEAF_MASK_STEP;
                                        while (leafmask.length > 0) {
                                            totalProductionOfStepCycle += parseInt(leafmask.substr(0, LEAF_MASK_STEP));
                                            leafmask = leafmask.substr(LEAF_MASK_STEP);
                                        }
                                        var totalCycleCount = production / totalProductionOfStepCycle;
                                        return parseFloat(groupDetailOfEvent.cycletime) * totalCycleCount;
                                    },
                                    remainingDurationCalculator: (event, recentMerges) => {
                                        var remaining = event._production;
                                        const tpp = getCorrectTppPres(event, event.scheduleRelation.mergeCandidates);
                                        for (const m of recentMerges) {
                                        if (m.merge) {
                                            var mouldId = m.merge.mouldName + ':|:' + m.merge.groupName;
                                            var group = t.data.Mould._cache[mouldId];
                                            var groupDetailOfEvent = group.filter(groupDetail => groupDetail.opname === event.title)[0];
                                            var totalProductionOfStepCycle = 0;
                                            var leafmask = groupDetailOfEvent.leafmask;
                                            var totalStepsOfCycle = leafmask.length / LEAF_MASK_STEP;
                                            while (leafmask.length > 0) {
                                                totalProductionOfStepCycle += parseInt(leafmask.substr(0, LEAF_MASK_STEP));
                                                leafmask = leafmask.substr(LEAF_MASK_STEP);
                                            }
                                            remaining -= totalProductionOfStepCycle * m.duration / parseFloat(groupDetailOfEvent.cycletime) /
                                            1000;
                                        } else {
                                            remaining -= m.duration / tpp / 1000;
                                        }
                                        }
                                        return remaining * tpp * 1000;
                                    }
                                });
                            }
                            if (mould !== lastMould) {
                                pushCandidates(candidatesOfMould, allowPartialMerge);
                                candidatesOfMould = [];
                            }
                            lastMould = mould;
                        }
                        if (candidatesOfMould.length > 0) {
                            pushCandidates(candidatesOfMould, allowPartialMerge);
                        }
                        return candidates;
                    }
                };
                var getCorrectTppKaynak = (event, mergeCandidates) => {
                    let tpp = event.tpp;
                    if (mergeCandidates) {
                        let singleCandidates = mergeCandidates.filter(candidate => Object.keys(candidate.detail).length === 1 &&
                        (event.resourceId ? candidate.targetResources.split(',').includes(event.resourceId) : true));
                        if (singleCandidates.length === 0 && mergeCandidates.length === 1) {
                            singleCandidates = mergeCandidates;
                        } else if (event.resourceId) {
                            singleCandidates = mergeCandidates.filter(candidate => candidate.targetResources.split(',').includes(event.resourceId));
                        }
                        if (singleCandidates.length > 0) {
                            tpp = Number.POSITIVE_INFINITY;
                            singleCandidates.forEach(singleCandidate => {
                                var mouldId = singleCandidate.mouldName + ':|:' + singleCandidate.groupName;
                                var group = t.data.Mould._cache[mouldId];
                                var groupDetailOfEvent = group.filter(groupDetail => groupDetail.opname === event.title)[0];
                                tpp = Math.min(tpp, parseFloat(groupDetailOfEvent.cycletime));
                            });
                        }
                    }
                    return tpp;
                };
                var getCorrectTppPres = (event, mergeCandidates) => {
                    let tpp = event.tpp;
                    if (mergeCandidates) {
                        let singleCandidates = mergeCandidates.filter(candidate => Object.keys(candidate.detail).length === 1 &&
                        (event.resourceId ? candidate.targetResources.split(',').includes(event.resourceId) : true));
                        if (singleCandidates.length === 0 && mergeCandidates.length === 1) {
                        singleCandidates = mergeCandidates;
                        } else if (event.resourceId) {
                        singleCandidates = mergeCandidates.filter(candidate => candidate.targetResources.split(',').includes(
                            event.resourceId));
                        }
                        if (singleCandidates.length > 0) {
                            tpp = Number.POSITIVE_INFINITY;
                            singleCandidates.forEach(singleCandidate => {
                                var mouldId = singleCandidate.mouldName + ':|:' + singleCandidate.groupName;
                                var group = t.data.Mould._cache[mouldId];
                                var groupDetailOfEvent = group.filter(groupDetail => groupDetail.opname === event.title)[0];
                                tpp = Math.min(tpp, parseFloat(groupDetailOfEvent.cycletime));
                            });
                        }
                    }
                    return tpp;
                };

                var events, plannedStops, plannedStopFactory, mergeCandidates;
                var zoomLevel = 34;
                if(t.appType==='pres-hat'){
                    events = copy(t.data.Scheduler.records);
                    events.sort(function(a, b) {
                        return a.start - b.start;
                    });
                    //for(var i = 0; i < events.length; i++){
                    //    events[i].scheduled = false;
                    //}
                    resources = copy(t.data.Client.records);
                    for(var i = 0; i < resources.length; i++){
                        resources[i].children=JSON.parse(resources[i].children);
                    }
                    plannedStops = copy(plannedStopsPattern);
                    plannedStopFactory = fnPlannedStopFactory;
                    predecessors = undefined;
                    successors = undefined;
                    mergeCandidates = mergeCandidatesPres;
                    eventListColumns = eventListColumnsPres;
                }else if(t.appType==='robot-kaynak'){
                    events = copy(t.data.Scheduler.records);
                    events.sort(function(a, b) {
                        return a.start - b.start;
                    });
                    //for(var i = 0; i < events.length; i++){
                    //    events[i].scheduled = false;
                    //}
                    for (var i = 0; i < events.length; i++) {
                        const event = events[i];
                        const tpp = getCorrectTppKaynak(event, mergeCandidatesKaynak(event, events));
                        event.duration = tpp * event._production * 1000;
                    }
                    resources = copy(t.data.Client.records);
                    for(var i = 0; i < resources.length; i++){
                        resources[i].children=JSON.parse(resources[i].children);
                    }
                    plannedStops = copy(plannedStopsPattern);
                    plannedStopFactory = fnPlannedStopFactory;
                    predecessors = undefined;
                    successors = undefined;
                    mergeCandidates = mergeCandidatesKaynak;
                    zoomLevel = 39;
                }
                events.forEach(event => {
                    // "2019-03-18 00:00:00"
                    // new Date(year, month, day, hours, minutes, seconds, milliseconds)
                    const dArr = event.start.split(' ');
                    const d0 = dArr[0].split('-');
                    const d1 = dArr[1].split(':');
                    event.start = new Date(d0[0], d0[1] - 1, d0[2], d1[0], d1[1], d1[2]);
                });
                const eventBoxTitleRenderer = (event, box, addTo, utils) => {
                    const Konva = utils.Konva;
                    const createSelector = utils.createSelector;

                    const padding = (box.height - box.titleFontSize) / 2 + +box.borderSize * 2
                    const titleGroup = new Konva.Group({
                        x: padding,
                        y: padding - box.borderSize,
                        clipX: 0,
                        clipY: 0,
                        clipWidth: box.titleClipWidth,
                        clipHeight: box.height // - padding * 2
                    })
                    const title = new Konva.Text({
                        fill: box.titleFontColor,
                        text: event.erprefnumber + ': ' + event.title,
                        fontFamily: box.titleFontFamily,
                        fontSize: box.titleFontSize,
                        fontStyle: box.titleFontStyle,
                        verticalAlign: 'top'
                    })
                    title.listening(false)

                    titleGroup.add(title)
                    addTo.add(titleGroup)
                    titleGroup.setZIndex(addTo.children.length - 1)

                    box.on('mouseenter', () => titleGroup.clipWidth(title.width()))
                    box.on('mouseleave', () => titleGroup.clipWidth(box.titleClipWidth))

                    const refreshTitleFontColor = createSelector(
                        values => values.titleFontColor,
                        titleFontColor => {
                        title.fill(titleFontColor)
                        }
                    )
                    const refreshTitleFontFamily = createSelector(
                        values => values.titleFontFamily,
                        titleFontFamily => {
                        title.fontFamily(titleFontFamily)
                        }
                    )
                    const refreshTitleFontSize = createSelector(
                        values => values.titleFontSize,
                        titleFontSize => {
                        title.fontSize(titleFontSize)
                        }
                    )
                    const refreshTitleFontStyle = createSelector(
                        values => values.titleFontStyle,
                        titleFontStyle => {
                        title.fontStyle(titleFontStyle)
                        }
                    )
                    const refreshTitleGroup = createSelector(
                        values => values.height,
                        values => values.titleFontSize,
                        values => values.borderSize,
                        values => values.titleClipWidth,
                        (height, titleFontSize, borderSize, titleClipWidth) => {
                        const padding = (height - titleFontSize) / 2 + +borderSize * 2
                        titleGroup.x(padding).y(padding).clipWidth(titleClipWidth).clipHeight(height - padding * 2)
                        titleGroup.getLayer().batchDraw()
                        }
                    )
                    box.on('refresh', (e) => {
                        refreshTitleFontColor(e.values)
                        refreshTitleFontFamily(e.values)
                        refreshTitleFontSize(e.values)
                        refreshTitleFontStyle(e.values)
                        refreshTitleGroup(e.values)
                    })
                    return title
                }
                const readonly=((window.location.href.indexOf('149/kaynak2')>-1||window.location.href.indexOf('149/kaynak1')>-1)?true:false);//||window.location.href.indexOf('149/pres')>-1
                scheduler.load({
                    logLevel: 5,
                    locale: 'tr',
                    events,
                    resources,
                    plannedStops,
                    plannedStopFactory,
                    translations,
                    predecessors,
                    successors,
                    mergeCandidates,
                    zoomLevel,
                    eventListColumns,
                    readonly,
                    eventBoxTitleRenderer
                });
            };
            t._load=_load;
            scheduler.componentOnReady().then(() => {
                _load();
            });

            return scheduler;
        }
        ,openTaskEditWindow(data){
            var t=this;
            if(t.winAddChildRecord==false){
                t.winAddChildRecord = new mj.window({
                    renderTo : mj.NE(),
                    title : "{{ 'Scheduler.winAddChildRecordTitle'|trans }}",
                    modal : true,
                    width : 800,
                    height : 400,
                    minWidth : 800,
                    minHeight : 400,
                    buttons : [
                        {title: mj.lng.glb.exit, handler:function(){t.winAddChildRecord.hide();}},
                        {title: mj.lng.glb.save, handler:function(){
                            var data=t.forms.childRecords.getValue();
                            data.duration=data._production*data.tpp*1000;
                            //console.log(data);
                            t.scheduler.updateEventData(data);
                            t.forms.childRecords.clear();
                            t.winAddChildRecord.hide();
                        }}
                    ]
                });
                t.win.addRelated(t.winAddChildRecord);
                t.forms.childRecords = new mj.form({
                    renderTo : t.winAddChildRecord.getBody(),
                    store : new mj.store({}),
                    buttonPos:false,
                    items:[
                        new mj.form.field({
                            dataIndex: 'id',
                            hidden: true
                        }),
                        new mj.form.field({
                            dataIndex: 'duration',
                            hidden: true
                        }),
                        new mj.form.field({
                            dataIndex: 'tpp',
                            hidden: true
                        }),
                        new mj.form.combo({
                            title: "{{ 'Scheduler.client'|trans }}",
                            placeHolder: "{{ 'Scheduler.client_placeholder'|trans }}",
                            dataIndex: 'resourceId',
                            labelWidth : '110px',
                            mode: 'remote',
                            clearOnTriggerClick: true,
                            notEmpty: true,
                            grid: 's12 m6',
                            store: t.stores.Client
                        }),
                        //new mj.form.combo({
                        //    title: "{{ 'Scheduler.opname'|trans }}",
                        //    placeHolder: "{{ 'Scheduler.opname_placeholder'|trans }}",
                        //    dataIndex: 'opname',
                        //    labelWidth : '110px',
                        //    mode: 'remote',
                        //    clearOnTriggerClick: true,
                        //    notEmpty: true,
                        //    grid: 's12 m6',
                        //    width:200,
                        //    store: t.stores.ProductTree
                        //}),
                        new mj.form.textField({
                            title: "{{ 'Scheduler.opname'|trans }}",
                            dataIndex: 'title',
                            width:200,
                            labelWidth : '110px',
                            disabled:true,
                            grid: 's12 m6'
                        }),
                        new mj.form.textField({
                            title: "{{ 'Scheduler.erprefnumber'|trans }}",
                            dataIndex: 'erprefnumber',
                            maxLength: 50,
                            labelWidth : '110px',
                            grid: 's12 m6'
                        }),
                        new mj.form.numberField({
                            title: "{{ 'Scheduler.productcount'|trans }}",
                            dataIndex: '_production',
                            labelWidth : '110px',
                            notEmpty: true,
                            grid: 's12 m6'
                        })
                    ]
                });
            }
            t.forms.childRecords.store.data = data;
            t.forms.childRecords.load();
            t.winAddChildRecord.show();
        }
        ,refresh: function() {
            var t = this;
            t.trigger('beforesave');
            if (typeof Routing !== 'undefined') {
                var id = false;
                var version = 0;
                var routeName = 'Scheduler-showall';
                var route = Routing.getRoute(routeName);
                var pagerParams = {
                    'pg': 1,
                    'lm': 9999
                };
                var url = Routing.generate(routeName, pagerParams);
                var data = {menuId:t.id};
                if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                    t.waitMaskShow();
                    $.ajax({
                        url: url,
                        method: "POST",
                        headers: { 
                            "Content-Type": "application/json",
                            "X-HTTP-Method-Override": route.methods[0] 
                        },
                        data: JSON.stringify(data),
                        dataType: 'json',
                        success: function(data, textStatus, jqXHR) {
                            t.waitMaskHide();
                            t.data=data;
                            t._load();
                        },
                        error: function(jqXHR, textStatus, errorThrown) {
                            t.waitMaskHide();
                            mj.message({
                                title: mj.lng.glb.error,
                                msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                type: "error",
                                html: true
                            });
                        },
                        complete: function(jqXHR, textStatus) {
                            //t.waitMaskHide();
                        }
                    });
                }
            }
        }
        ,save: function(_data) {
            var t = this;
            t.trigger('beforesave');
            if (typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var id = false;
                    var version = 0;
                    var routeName = 'Scheduler-add';
                    var route = Routing.getRoute(routeName);
                    var pagerParams = {
                        'pg': 1,
                        'lm': 5000
                    };
                    var url = Routing.generate(routeName, pagerParams);
                    var data = {menuId:t.id,data:_data};
                    for(var i=0;i<data.data.length;i++){
                        console.log(data.data[i]);
                        data.data[i].start=data.data[i].start.toLocaleDateString('tr', { day: '2-digit', month: '2-digit', year: 'numeric' }).split('.').reverse().join('-')+' '+data.data[i].start.toLocaleTimeString();
                        data.data[i].finish=data.data[i].end.toLocaleDateString('tr', { day: '2-digit', month: '2-digit', year: 'numeric' }).split('.').reverse().join('-')+' '+data.data[i].end.toLocaleTimeString();
                    }
                    //console.log(data);
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t._event='save';
                        $.ajax({
                            url: url,
                            method: "POST",
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            data: JSON.stringify(data),
                            dataType: 'json',
                            success: function(data, textStatus, jqXHR) {
                                //t.reset(_f, data);
                                t.scheduler.clearHistory();
                                //t.activateTabGrid();
                                t.waitMaskHide();
                            },
                            error: function(jqXHR, textStatus, errorThrown) {
                                //console.log(jqXHR);
                                //console.log(textStatus);
                                //console.log(errorThrown);
                                t.waitMaskHide();
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                    type: "error",
                                    html: true
                                });
                            },
                            complete: function(jqXHR, textStatus) {
                                //t.waitMaskHide();
                            }
                        });
                    }
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
